\documentclass{standalone}

\input{../../macros/macros}

\usepackage{../../../msc}

\begin{document}
\setlength{\firstlevelheight}{0.4cm}
\begin{msc}[msc keyword=, draw frame = none, instance distance=4cm,%
        head top distance=0cm, foot distance=0cm]{}
\declinst{p}{}{P (Reader)}
\declinst{v}{}{V (Device)}
\action*{nonce $p, n_p$}{p}
\action*{nonce $v, n_v$}{v}
\nextlevel[2]
\mess{$hello$}{p}{v}
\nextlevel[1.5]
\mess*{$n_v$}{v}{p}
\measure[r]{max $\Delta$}{v}{v}[1.5]
\nextlevel[1.5]
\mess*{$n_v\xor g^p$}{p}{v}
\nextlevel[1.5]
\mess*{$n_p$}{p}{v}
\measure{max $\Delta$}{p}{p}[1.5]
\nextlevel[1.5]
\mess*{$n_p\xor g^v$}{v}{p}
\nextlevel[1]
\action*{$k = (g^p)^v$}{v}
\action*{$k = (g^v)^p$}{p}
\nextlevel[2]
\mess{$\enc{\pair{n_v}{n_p}}{k}$}{p}{v}
\nextlevel[1.5]
\mess{$\enc{\pair{n_p}{n_v}}{k}$}{v}{p}
\nextlevel[1]
\condition*{$k$ is secret}{v}
\condition*{$k$ is secret}{p}
\nextlevel[2]
\condition*{$V$ is communicating with $P$}{v}
\condition*{$P$ is communicating with $V$}{p}
\nextlevel[1]
\end{msc}

\end{document}
